<?php
/***********************************************************************
  FILE:     journals.inc.php
  VERSION:  0.1
  BEGUN:    22nd November 2002
  AUTHOR:   Alison S. Blazow (dee)
  PURPOSE:  Updates to livejournal.com & deadjournal.com
  NOTES:    Based off info at the lj site as well as b2's 
  	    <http://cafelog.com> lj update interface.
***********************************************************************/

//= COMMON FUNCTIONS =================================================//
// breaks a formatted time/date string into pieces and returns them as an array
// "Y-m-d H:i:s"
// I'm sure that there's a way to do this more efficiently with preg_split
function lj_tmbr( $pdt ) {
	$z = explode( " ", $pdt );
	$z_d = explode( "-", $z[0] );
	$z_t = explode( ":", $z[1] );
	$zdt = array( "year" => $z_d[0], "mon" => $z_d[1], "day" => $z_d[2], "hour" => $z_t[0], "min" => $z_t[1] );
	return( $zdt );
}

function pdbg( $var ) {
	echo "<pre>";
	print_r( $var );
	echo "</pre>";
}

function journal_call_update( $jnums, $post ){
  global $sitename, $home_url;
  
  foreach( $jnums as $k => $v ) {
    
    $j = mysql_fetch_object( mysql_query( "SELECT * FROM journalxref WHERE journalID = '$k'" ) );
    
    //- prop data ----------------------------------------------------//
    // set the all-important picture
    $parr = explode( ',', $j->journalPicKeys );
    shuffle( $parr );
    $jmeta['picture_keyword'] = $parr[0];
    
    // set autobr meta-flag
    // linebreaks are always done in applyformat()
    $jmeta['opt_preformatted'] = 1;
    
    // remove comments for all security restricted comments
    // since lj doesn't really support this feature
    if( $post->postCom == 'All' )
      $jmeta['opt_nocomments'] = 0;
    else
      $jmeta['opt_nocomments'] = 1;
    
    // current music
    $mu = mysql_fetch_object( mysql_query( "SELECT * FROM log_currents WHERE postID = '$post->postID' AND curType = 'music'" ) );
    if( !empty( $mu->curText ) )
      $jmeta['current_music'] = $mu->curText;
    
    // current mood
    $mo = mysql_fetch_object( mysql_query( "SELECT * FROM log_currents WHERE postID = '$post->postID' AND curType = 'mood'" ) );
    if( $mo->curID == 0 && !empty( $mo->curText ) )
      $jmeta['current_mood'] = $mo->curText;
    elseif( $mo->curID != 0 ){
      $mj = mysql_fetch_object( mysql_query( "SELECT ljMoodID FROM moodxref WHERE moodID = '$mo->curID'" ) );
      $jmeta['current_moodid'] = $mj->ljMoodID;
    }
    
    //- basic data ---------------------------------------------------//
    $jdata['postID'] = $post->postID;
    $jdata['journalID'] = $k;
    $jdata['server'] = $j->journalServer;
    $jdata['username'] = $j->journalUser;
    $jdata['hpassword'] = $j->journalPass;
    $jdata['subject'] = "[ $post->postCat ] $post->postTitle";
    
    // format post
    $f = applyformat( $post, 'lj' );
    $jdata['event'] = "$f <br><font size=\"1\">[cloned from <a href=\"$home_url/archive.php?postID=$post->postID\">$sitename</a>]</font>";
      
    // time data
    $jdata = array_merge( $jdata, lj_tmbr( $post->postDateTime ) );
    
    
    // apply privacy settings; hush group taken from journalxref table
    if( $post->postVis == 'All' ) {
      $jdata['security'] = "public";
    } elseif( $post->postVis == 'Registered' ) {
      $jdata['security'] = "usemask";
      $jdata['allowmask'] = 1;
    } elseif( $post->postVis == 'Hush' ) {
      $jdata['security'] = "usemask";
      $jdata['allowmask'] = $j->journalHush;
    } else {
      $jdata['security'] = "private";
    }
    
    //- function call ------------------------------------------------//
    lj_update( $jdata, $jmeta );
  }

}

function journal_call_edit( $jnums, $post ){
  global $sitename, $home_url;
  
  foreach( $jnums as $k => $v ) {
    $str = "SELECT jx.*, jid.journalRemID FROM journalxref=jx, journal_logid=jid ".
           "WHERE jx.journalID = '$k' ".
           "AND jx.journalID = jid.journalID ".
           "AND jid.postID = '$post->postID'";
           
    $j = mysql_fetch_object( mysql_query( $str ) )
      or die( mysql_error() );
    
    //- prop data ----------------------------------------------------//
    // check if the post needs backdating
    $isold = mysql_num_rows( mysql_query( "SELECT * FROM log_posts WHERE postDateTime > '$post->postDateTime'" ) );
    if( $isold )
      $jmeta['opt_backdated'] = 1;
    
    // set the all-important picture
    $parr = explode( ',', $j->journalPicKeys );
    shuffle( $parr );
    $jmeta['picture_keyword'] = $parr[0];
    
    // set autobr meta-flag
    // linebreaks are always done in applyformat()
    $jmeta['opt_preformatted'] = 1;
    
    // remove comments for all security restricted comments
    // since lj doesn't really support this feature
    if( $post->postCom == 'All' )
      $jmeta['opt_nocomments'] = 0;
    else
      $jmeta['opt_nocomments'] = 1;
    
    // current music
    $mu = mysql_fetch_object( mysql_query( "SELECT * FROM log_currents WHERE postID = '$post->postID' AND curType = 'music'" ) );
    if( !empty( $mu->curText ) )
      $jmeta['current_music'] = $mu->curText;
    
    // current mood
    $mo = mysql_fetch_object( mysql_query( "SELECT * FROM log_currents WHERE postID = '$post->postID' AND curType = 'mood'" ) );
    if( $mo->curID == 0 && !empty( $mo->curText ) )
      $jmeta['current_mood'] = $mo->curText;
    elseif( $mo->curID != 0 ){
      $mj = mysql_fetch_object( mysql_query( "SELECT ljMoodID FROM moodxref WHERE moodID = '$mo->curID'" ) );
      $jmeta['current_moodid'] = $mj->ljMoodID;
    }
    
    //- basic data ---------------------------------------------------//
    $jdata['postID']    = $post->postID;
    $jdata['journalID'] = $k;
    $jdata['itemid']    = $j->journalRemID;
    $jdata['server']    = $j->journalServer;
    $jdata['username']  = $j->journalUser;
    $jdata['hpassword'] = $j->journalPass;
    $jdata['subject']   = "[ $post->postCat ] $post->postTitle";
    
    // format post
    $f = applyformat( $post, 'lj' );
    $jdata['event'] = "$f<br><font size=\"1\">[cloned from <a href=\"$home_url/archive.php?postID=$post->postID\">$sitename</a>]</font>";
      
    // time data
    $jdata = array_merge( $jdata, lj_tmbr( $post->postDateTime ) );
    
    
    // apply privacy settings; hush group taken from journalxref
    if( $post->postVis == 'All' ) {
      $jdata['security'] = "public";
    } elseif( $post->postVis == 'Registered' ) {
      $jdata['security'] = "usemask";
      $jdata['allowmask'] = 1;
    } elseif( $post->postVis == 'Hush' ) {
      $jdata['security'] = "usemask";
      $jdata['allowmask'] = $j->journalHush;
    } else {
      $jdata['security'] = "private";
    }
    
    //- function call ------------------------------------------------//
    lj_edit( $jdata, $jmeta );
  }
  

  
}

function journal_call_delete( $postID, $journalID ){
      
  $str = "SELECT jx.*, jid.postID, jid.journalRemID FROM journalxref=jx, journal_logid=jid ".
         "WHERE jid.postID = '$postID' ".
         "AND jid.journalID = jx.journalID AND jid.journalID = '$journalID'";
         
  $sql = mysql_query( $str )
    or die( mysql_error() );

  while( $j = mysql_fetch_object( $sql ) ) {
    
    $jdata['postID']    = $j->postID;
    $jdata['journalID'] = $j->journalID;
    $jdata['itemid']    = $j->journalRemID;
    $jdata['server']    = $j->journalServer;
    $jdata['username']  = $j->journalUser;
    $jdata['hpassword'] = $j->journalPass;
    
    //- function call ------------------------------------------------//
    lj_delete( $jdata );
  }

}


//= LIVEJOURNAL FUNCTIONS ============================================//
//function lj_update( $post_ID, $user_ID, $pdt, $title, $content, $username, $password, $server ) {
function lj_update( $jdata, $jmeta ) {

  $ljc = new LJClient( $jdata['username'], $jdata['hpassword'], $jdata['server'] );
	
  $jdata['event'] = stripslashes( stripslashes( $jdata['event'] ) );  // OUCH HACK!
	
  $response = $ljc->postevent( $jdata, $jmeta );
  
  $fc = $response->faultCode();
  if ( $fc == 0 ) {
    //$ret_val = true;
    $rsp = xmlrpc_decode( $response->value() );
    //foreach( $rsp as $k => $v )
      //print "[ $k ] $v<br>";
      
    $qsql = "INSERT INTO journal_logid ( journalID, postID, journalRemID, journalRemAnum ) ".
            "VALUES ( '$jdata[journalID]', '$jdata[postID]', '$rsp[itemid]', '$rsp[anum]' )";
    mysql_query( $qsql )
      or die( mysql_error() );
      
  } else
    print( "<b>XMLRPC Error:</b> ". $response->faultString() . "(<i>$jdata[server] update</i>)<br>" );
}

//function lj_delete($post_ID, $user_ID, $username, $password, $server ) {
function lj_delete( $jdata ) {
  		
  $ljc = new LJClient( $jdata['username'], $jdata['hpassword'], $jdata['server'] );

  //$response = $ljc->editevent( $lj->LJID, "", "", "", "", "", "", "", "" );
  $response = $ljc->editevent( $jdata, "" );
    
  $fc = $response->faultCode();
  if( $fc == 0 ) {

    $rsp = xmlrpc_decode( $response->value() );
    
    mysql_query( "DELETE FROM journal_logid WHERE journalID = '$jdata[journalID]' AND postID = '$jdata[postID]' AND journalRemID = '$jdata[itemid]'" );

  } else
    print( "<b>XMLRPC Error:</b> ". $response->faultString() . "(<i>$jdata[server] delete</i>)<br>" );

}

//function lj_edit($post_ID, $user_ID, $pdt, $title, $content, $username, $password, $server) {
function lj_edit( $jdata, $jmeta ){

  $ljc = new LJClient(  $jdata['username'], $jdata['hpassword'], $jdata['server'] );

  $jdata['event'] = stripslashes( stripslashes( $jdata['event'] ) );  // OUCH HACK!
		
  $response = $ljc->editevent( $jdata, $jmeta );
		
  $fc = $response->faultCode();
  if ( $fc != 0 ){
    $rsp = xmlrpc_decode( $response->value() );
    //foreach( $rsp as $k => $v )
      //print "[ $k ] $v<br>";
      
    print( "<b>XMLRPC Error:</b> ". $response->faultString() . "(<i>$jdata[server] edit</i>)<br>" );
  }

}


//= XML_RPC CLASSES ==================================================//

//- lj xml-rpc class -------------------------------------------------//
class LJClient {

  // see http://www.livejournal.com/doc/server/ljp.csp.xml-rpc.protocol.html
  // for documentation on the livejournal XML-RPC interface

  // ------------------------------------------------------------
  var $clientid;
  var $protocol_version;
  var $lineendings;
  var $rpc_timeout;
  var $journal_url;

  var $lj_srvr;
  var $lj_port;
  var $lj_xmlrpcuri;

  var $lj_userid;
  var $lj_passwd;

  var $lj_loggedin;
  // ------------------------------------------------------------

  function LJClient( $lj_userid = "", $lj_passwd = "", $server = "" ){
    $this->clientid = "PHP-SKLog/0.5.1";
    $this->protocol_version = 0;
    $this->lineendings = "unix";
    $this->rpc_timeout = 60;

    $this->lj_srvr = $server;
    $this->lj_port = "80";
    $this->lj_xmlrpcuri = "/interface/xmlrpc";

    $this->lj_logged = false;
    $this->lj_userid = $lj_userid;
    $this->lj_passwd = $lj_passwd; // needs password in md5
    $this->client = new xmlrpc_client( $this->lj_xmlrpcuri, $this->lj_srvr, $this->lj_port );
  }

  // ------------------------- API ------------------------------

  function login(){
    $lj_method = "LJ.XMLRPC.login";
    $params = array( xmlrpc_encode( array( 
        "username" => $this->lj_userid,
        "hpassword" => $this->lj_passwd,
        "ver" => $this->protocol_version,
        "clientversion" => $this->clientid
      ) ) );
      
    // print_r( xmlrpc_decode( $params[0] ) );
		
    $response = $this->do_the_thing( $lj_method, $params );
    $fc = $response->faultCode();
    if ( $fc == 0 ) {
      $this->loggedin = true;
      // if we want to do anything with the values from the server
      // this is where we'd do it
      // $rsp = xmlrpc_decode( $response->value() );
      return( true );
    }
      return( false );
  }

  //function postevent( $subject, $event, $evt_year, $evt_month, $evt_day, $evt_hour, $evt_minute, $meta_props ){
  // post a new event
  function postevent( $jdata, $jmeta ){

    $this->chk_login();

    $lj_method = "LJ.XMLRPC.postevent";
    $params = array( xmlrpc_encode( array(
        "username" => $this->lj_userid,
        "hpassword" => $this->lj_passwd,
        "ver" => $this->protocol_version,
        "lineendings" => $this->lineendings,
        "subject" => $jdata['subject'],
        "event" => $jdata['event'],
        "year" => $jdata['year'],
        "mon" => $jdata['mon'],
        "day" => $jdata['day'],
        "hour" => $jdata['hour'],
        "min" => $jdata['min'],
        "security" => $jdata['security'],
        "allowmask" => $jdata['allowmask'],
        "props" => $jmeta
      ) ) );
      
    // pdbg( xmlrpc_decode( $params[0] ) );
    
    $response = $this->do_the_thing( $lj_method, $params );
    return( $response );
  }

  //function editevent( $id, $subject, $event, $evt_year, $evt_month, $evt_day, $evt_hour, $evt_minute, $meta_props ){
  // edit/delete an old event
  function editevent( $jdata, $jmeta ){
    $this->chk_login();

    $lj_method = "LJ.XMLRPC.editevent";
    $params = array( xmlrpc_encode( array( 
        "username" => $this->lj_userid,
        "hpassword" => $this->lj_passwd,
        "ver" => $this->protocol_version,
        "lineendings" => $this->lineendings,
        "itemid" => $jdata['itemid'],
        "subject" => $jdata['subject'],
        "event" => $jdata['event'],
        "year" => $jdata['year'],
        "mon" => $jdata['mon'],
        "day" => $jdata['day'],
        "hour" => $jdata['hour'],
        "min" => $jdata['min'],
        "security" => $jdata['security'],
        "allowmask" => $jdata['allowmask'],
        "props" => $jmeta
      ) ) );
    
    // pdbg( xmlrpc_decode( $params[0] ) );
    
    $response = $this->do_the_thing( $lj_method, $params );
    return( $response );
  }

  // ------------------------------------------------------------

  // ------------------- Internal Functions ---------------------

  function do_the_thing( $method, $params ){
    $xmlrpc_msg = new xmlrpcmsg( $method, $params );
    $xmlrpc_rsp = $this->client->send( $xmlrpc_msg, $this->rpc_timeout );
    
    return( $xmlrpc_rsp );
  }

  function chk_login(){
    if ( $this->loggedin == false ){
      $this->login();
    }
  }

  // ------------------------------------------------------------

}

?>