<?php
/***********************************************************************
  FILE:     logcode.inc.php
  VERSION:  0.1
  BEGUN:    26th August 2002
  AUTHOR:   Alison S. Blazow (dee)
  PURPOSE:  Post formatting
***********************************************************************/

if (!empty($_POST)) {
        extract($_POST);
    } else if (!empty($HTTP_POST_VARS)) {
        extract($HTTP_POST_VARS);
    } // end if

function post_format( $post ){
  global $DINGBAT;

  $post = convert_users( $post );

  // email : taken from b2 <http://cafelog.com>
  $logcode_email["in"] = array(
    '#\[email](.+?)\[/email]#eis',
    '#\[email=(.+?)](.+?)\[/email]#eis'
  );
  $logcode_email["out"] = array(
    "'<a href=\"mailto:'.antispambot('\\1').'\">'.antispambot('\\1').'</a>'",
    "'<a href=\"mailto:'.antispambot('\\1').'\">\\2</a>'"
  );

  $post = preg_replace( $logcode_email["in"], $logcode_email["out"], $post );
  
  // links : see above disclaimer
  $logcode["in"] = array(
	'#\[b](.+?)\[/b]#is',		// Formatting tags
	'#\[i](.+?)\[/i]#is',
	'#\[u](.+?)\[/u]#is',
	'#\[s](.+?)\[/s]#is',
	'#\[small](.+?)\[/small]#is',
	'#\[quote](.+?)\[/quote]#is',
	'#\[quote=(.+?)](.+?)\[/quote]#is',
	'#\[quote=(.+?) url=(.+?)](.+?)\[/quote]#is',
	//'#\\*\*(.+?)\\*\*#is',		// **bold**
	//'#\\\\(.+?)\\\\#is',		// \\italic\\
	//'#\__(.+?)\__#is',		// __underline__
	'#\[lj user=(.+?)]#is',  // lj users
	'#\[lj comm=(.+?)]#is',  // lj communities
	'#\[color=(.+?)](.+?)\[/color]#is',
	'#\[size=(.+?)](.+?)\[/size]#is',
	'#\[font=(.+?)](.+?)\[/font]#is',
	'#\[img](.+?)\[/img]#is',		// Image
	'#\[url](.+?)\[/url]#is',		// URL
	'#\[url=(.+?)](.+?)\[/url]#is',
	'#\[dex](.+?)\[/dex]#is',		// Blogdex linked
	'#\[dex=(.+?)](.+?)\[/dex]#is'
  );
  $logcode["out"] = array(
	'<b>$1</b>',		// Formatting tags
	'<i>$1</i>',
	'<span style="text-decoration: underline">$1</span>',
	'<span style="text-decoration: line-through">$1</span>',
	'<span class="small">$1</span>',
	'<blockquote><div class="quote">$1</div></blockquote>',
	'<blockquote><div class="quote">$2<br /><span class="small">quoted from: $1</span></div></blockquote>',
	'<blockquote><div class="quote">$3<br /><span class="small">quoted from: <a href="$2">$1</a></span></div></blockquote>',
	//'<b>$1</b>',
	//'<i>$1</i>',
	//'<span style="text-decoration:underline">$1</span>',
	'<a href="http://www.livejournal.com/userinfo.bml?user=$1" class="nodec"><img src="http://stat.livejournal.com/img/userinfo.gif" border="0"></a><b><a href="http://www.livejournal.com/users/$1/">$1</a></b>',
	'<a href="http://www.livejournal.com/userinfo.bml?user=$1" class="nodec"><img src="http://stat.livejournal.com/img/community.gif" border="0"></a><b><a href="http://www.livejournal.com/community/$1/">$1</a></b>',
	'<span style="color:$1">$2</span>',
	'<span style="font-size:$1px">$2</span>',
	'<span style="font-family:$1">$2</span>',
	'<img src="$1" alt="" />',		// Image
	'<a href="$1">$1</a>',		// URL
	'<a href="$1" title="$2 '. htmlentities( $DINGBAT ) .' $1">$2</a>',
	'<a href="$1">$1</a><a href="javascript:dex(\'$1\');">*</a>',		// Blogdex linked
	'<a href="$1" title="$2 '. htmlentities( $DINGBAT ) .' $1">$2</a><a href="javascript:dex(\'$1\');">*</a>'
  );

  $post = preg_replace( $logcode["in"], $logcode["out"], $post );

  
  
  return $post;
}
// do text cuts
function cut_text( $post, $postID, $op ){
  $cut_num = 1;
  
  $cut["in"] = array(
    '#\[cut](.+?)\[/cut]#eis',
    '#\[cut=(.+?)](.+?)\[/cut]#eis'
  );
  $cut["out"] = array(
    '"<b>( <a href=\"archive.php?postID=$postID#". num_inc( $cut_num ) ."\">more</a> )</b>"',
    '"<b>( <a href=\"archive.php?postID=$postID#". num_inc( $cut_num ) ."\">$1</a> )</b>"'
  );
  $cut["out_yes"] = array(
    '"<a name=\"". num_inc( $cut_num ) ."\"></a> $1"',
    '"<a name=\"". num_inc( $cut_num ) ."\"></a> $2"'
  );
  $cut["out_lj"] = array(
    '"<lj-cut>$1</lj-cut>"',
    '"<lj-cut text=\"$1\">$2</lj-cut>"'
  );
  
  switch( $op ){
    case 'no': // hide cuts
        $post = stripslashes( preg_replace( $cut["in"], $cut["out"], $post ) );
      break;
    case 'yes': // show cuts
        $post = stripslashes( preg_replace( $cut["in"], $cut["out_yes"], $post ) );
      break;
    case 'lj': // insert livejournal cut tags
        $post = stripslashes( preg_replace( $cut["in"], $cut["out_lj"], $post ) );
      break;
  }
  
  return $post;
  
}
function num_inc( &$cut_num ){
  return $cut_num++;
}

// add smilies
function convert_smilies( $content ) {
  //global $b2smiliestrans, $smilies_directory, $use_smilies;
  global $home_url;
  
  $sql = mysql_query( "SELECT * FROM smiliexref" );

  while( $s = mysql_fetch_object( $sql ) ) {
    $content = str_replace($s->smilieName, "<img src=\"". $home_url ."/images/smilies/". $s->smiliePic .".gif\" alt=\"$s->smilieName\" />", $content);
  }

  return ($content);
}

// add usernames
function convert_users( $content ) {
  //global $b2smiliestrans, $smilies_directory, $use_smilies;
  global $home_url;
  
  $sql = mysql_query( "SELECT * FROM userxref" );

  while( $u = mysql_fetch_object( $sql ) ) {
    
    $str = "<a href=\"$home_url/profile.php?userID=$u->userID\" title=\"$u->userTitle\"><b>$u->userDispName</b></a>";
    
    if( !empty( $u->userURL ) )
      $str .= " [<a href=\"$u->userURL\" title=\"". $u->userDispName ."'s Home\">h</a>]";
    
    $content = str_replace( ":user". $u->userUname .":", $str, $content);
  }

  return ($content);
}

// anti-spam bot taken from b2 <http://cafelog.com>
function antispambot( $emailaddy ) {
	$emailNOSPAMaddy = '';
	srand ((float) microtime() * 1000000);
	for ($i = 0; $i < strlen($emailaddy); $i = $i + 1) {
		if (floor(rand(0,1))) {
			$emailNOSPAMaddy .= "&#".ord(substr($emailaddy,$i,1)).";";
		} else {
			$emailNOSPAMaddy .= substr($emailaddy,$i,1);
		}
	}
	$emailNOSPAMaddy = str_replace('@','&#64;',$emailNOSPAMaddy);
	return $emailNOSPAMaddy;
}

?>